package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import org.semanticweb.lp.IntegerTerm;
import org.semanticweb.lp.Term;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public class GLPTermInteger extends GLPTerm {
    Integer i;


    /**
     *  Constructor for the GLPTermInteger object
     *
     *@param  i  Description of the Parameter
     */
    public GLPTermInteger(Integer i) {
        this.i = i;
    }



    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Term toLPTerm() {
        return new IntegerTerm(i.intValue());
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public GLPTerm copyTerm() {
        return new GLPTermInteger(i);
    }


    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     */
    public void renameVariables(HashMap h) { }


    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     *@return    Description of the Return Value
     */
    public GLPTerm copyTerm(HashMap h) {
        return new GLPTermInteger(i);
    }


    /**
     *  Description of the Method
     *
     *@param  free   Description of the Parameter
     *@param  bound  Description of the Parameter
     */
    public void freeBoundVariables(HashSet free, HashSet bound) {
        return;
    }
    
     /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return i.toString();
    }
    
}
