package org.semanticweb.lp;

import java.util.ArrayList;
import java.util.Iterator;


/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class ProgramClause extends FormulaObject {
    Literal[] head;
    Literal[] body;


    /**
     *  Constructor for the ProgramClause object
     *
     *@param  head  Description of the Parameter
     *@param  body  Description of the Parameter
     */
    public ProgramClause(Literal[] head, Literal[] body) {
        this.head = head;
        this.body = body;
    }


    /**
     *  Constructor for the ProgramClause object
     *
     *@param  head  Description of the Parameter
     *@param  body  Description of the Parameter
     */
    public ProgramClause(ArrayList head, ArrayList body) {
        //if(head!=null) {
          this.head = new Literal[head.size()];
          this.head = (Literal[]) head.toArray(this.head);
        //}
        if(body!= null) {
          this.body = new Literal[body.size()];
          this.body = (Literal[]) body.toArray(this.body);
        }
    }


    /**
     *  Constructor for the ProgramClause object
     *
     *@param  body  Description of the Parameter
     */
    public ProgramClause(Literal[] body) {
        this.head = null;
        this.body = body;
    }


    /**
     *  Gets the query attribute of the ProgramClause object
     *
     *@return    The query value
     */
    public boolean isQuery() {
        return ((head == null) || (head.length == 0));
    }


    /**
     *  Gets the body attribute of the ProgramClause object
     *
     *@return    The body value
     */
    public Literal[] getBody() {
        return body;
    }


    /**
     *  Gets the head attribute of the ProgramClause object
     *
     *@return    The head value
     */
    public Literal[] getHead() {
        return head;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        String result = "";
        if ((head != null) && (head.length > 0)) {
            for (int i = 0; i < head.length; i++) {
                result = result.concat(head[i].toString());
                if (i < head.length - 1) {
                    result = result.concat(", ");
                }
            }
        }
        if ((body != null) && (body.length > 0)) {
            result = result.concat(" :- ");
            for (int i = 0; i < body.length; i++) {
                result = result.concat(body[i].toString());
                if (i < body.length - 1) {
                    result = result.concat(", ");
                }
            }
        }
        result = result.concat(".");
        return result;
    }

    public String toPrologString(ArrayList answerVars) { // [MS]
      // answerVars are lp.VariableTerm
      StringBuffer result = new StringBuffer();
      if ((head != null) && (head.length > 0)) {
        for (int i = 0; i < head.length; i++) {
          result.append(head[i].toString());
          if ((body != null) && (body.length > 0)) {
            result.append(" :- ");
            for (int j = 0; j < body.length; j++) {
              result.append(body[j].toString());
              if (j < body.length-1) result.append(", ");
            }
          }
          result.append(".\n");
        }
      } else { // query (empty head)
        if ((body != null) && (body.length > 0)) {
          result.append(":- ");
          for (int j = 0; j < body.length; j++) {
            result.append(body[j].toString());
            result.append(", ");
          }
          /* old version: show instantiated queries
          result.append("write_triple((");
          for (int j = 0; j < body.length; j++) {
            result.append(body[j].toString());
            if (j < body.length-1) result.append(", ");
          }
          result.append(")), nl, fail.\n");
          */
          // new version: show variable bindings
          if (answerVars != null && answerVars.size() > 0) {
            for (Iterator varIter = answerVars.iterator(); varIter.hasNext();) {
              VariableTerm var = (VariableTerm)varIter.next();
              result.append("write('" + var.getVariable() + " = '), ");
              result.append("write_triple(" + var.toString() + "), ");
              if (varIter.hasNext()) result.append("write(', '), ");
            }
          } else { // no vars, answer with "true"
            result.append("write(true), ");
          }
          result.append("nl, fail.\n");
        }
      }
      return result.toString();
    }

}
