package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Matching extends Operation {

    /**
     *  Constructor for the Matching object
     *
     *@param  R1   Description of the Parameter
     *@param  ix1  Description of the Parameter
     *@param  R2   Description of the Parameter
     *@param  ix2  Description of the Parameter
     *@param  D    Description of the Parameter
     *@param  T    Description of the Parameter
     */
    public Matching(Atoms R1, int ix1[], Atoms R2, int ix2[], Atoms D, long T) {
        super(R1, ix1, R2, ix2, T);
        this.D = D;
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        int i;
        GroundAtom f;
        GroundAtom ins;
        Variable v;
        boolean res = true;
        // boolean del;
        Atom t = (Atom) t1;
        res = t.Match(t2);
        if (res) {
            //flag = true;
            f = new GroundAtom(D.arity);
            for (v = t.variables, i = 0; v != null; v = v.next, i++) {
                f.terms[i] = v.subsby;
            }
            ins = D.Insert(f);
            t2.Supports(ins);
            if (ins == f) {
                f.next2 = D.tuples2;
                D.tuples2 = f;
            }
        }
        for (v = t.variables, i = 0; v != null; v = v.next, i++) {
            v.subsby = null;
        }
        if (t.lasttouched < timestamp) {
            t.next2 = R1.tuples2;
            R1.tuples2 = t;
            t.lasttouched = timestamp;
        }
        if (t2.lasttouched < timestamp) {
            t2.next2 = R2.tuples2;
            R2.tuples2 = t2;
            t2.lasttouched = timestamp;
        }
    }
}
