package org.semanticweb.triple.inference;

/*
 *  Name: RuleAtom.java
 *  Version: 1.1
 *  Purpose: represents atoms in a rule
 *  History: attributes for detecting cycles in the system graph added (jan)
 */
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class RuleAtom extends Atom {
    /**
     *  Description of the Field
     */
    public Filter filter = null;
    /**
     *  Description of the Field
     */
    public Atoms up = null;
    // Substitutionen fr die Variablen des Atoms
    /**
     *  Description of the Field
     */
    public Atoms down = null;
    // Substituierte Atome fr Downpropagierung
    /**
     *  Description of the Field
     */
    public Atoms adddown = null;
    // inkrementelle Berechnung
    /**
     *  Description of the Field
     */
    public Atoms addup = null;
    // inkrementelle Berechnung
    /**
     *  Description of the Field
     */
    public int symbol;
    // Prdikatsymbol
    /**
     *  Description of the Field
     */
    public Rule rule = null;
    // Verweis auf Regel
    RuleAtom next = null;
    // Verzeigerung innerhalb von RuleSet
    RuleAtom last = null;
    // Doppeltverzeigerung innerhalb von RuleSet
    Variable vars1[];
    // index to the variables of the atom
    int vars2[];
    // index to the symbols of the variables of the atom
    int vars3[];
    // index is the symbol of the variable, content indicates column of the relation
    int index1[];
    // indicates the join columns
    int index2[];
    // indicates the join columns

    boolean visited = false;
    // fr den algorithmus zur Bestimmung starker Komponenten in RuleSet
    boolean stacked = false;
    // ""
    int dfbi = 0;
    // ""
    int q = 0;


    // ""

    /**
     *  Constructor for the RuleAtom object
     *
     *@param  sym    Description of the Parameter
     *@param  terme  Description of the Parameter
     */
    public RuleAtom(int sym, Term terme[]) {
        // sym = Prdikatsymbols, anz = Stelligkeit, terme = Feld mit Referenzen auf Terme
        super(terme);
        Variable v;
        symbol = sym;
        int j;
        int i;
        int max;
        vars1 = new Variable[anzvars + 1];
        vars2 = new int[anzvars + 1];
        index1 = new int[anzvars + 1];
        for (v = variables, j = 0; v != null; v = v.next, j++) {
            vars1[j] = v;
            vars2[j] = v.symbol;
            index1[j] = -1;
        }
        vars1[j] = null;
        vars2[j] = -1;
        index1[j] = -1;
        max = -1;
        for (i = 0; i < anzvars; i++) {
            if (max < vars2[i]) {
                max = vars2[i];
            }
        }
        vars3 = new int[max + 1];
        for (i = 0; i <= max; i++) {
            vars3[i] = -1;
        }
        for (i = 0; i < anzvars; i++) {
            vars3[vars2[i]] = i;
        }

    }


    /**
     *  Description of the Method
     */
    public void ClearRuleAtom() {
        // Lschen der aufgesammelten Zwischenergebnisse
        up = new Atoms(up.arity);
        addup = new Atoms(addup.arity);
        down = new Atoms(down.arity);
        adddown = new Atoms(adddown.arity);
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     */
    public void internalize(PrintStream p) {
        p.print("p" + String.valueOf(symbol));
        super.internalize(p);
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     */
    public void print(PrintStream p) {
        // int i;
        p.print("p");
        p.print(symbol);
        //System.out.print((char)((int)('p')+symbol));
        p.print('(');
        super.print(p);
        p.print(')');
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        // int i;
        String s;
        s = "p";
        s += Integer.toString(symbol);
        //System.out.print((char)((int)('p')+symbol));
        s += "(";
        s += super.toString();
        s += ')';
        if (cycle) {
            s += " cycle";
        }
        else {
            s += " nocycle";
        }
        return s;
    }
}
