package org.semanticweb.triple.inference;
import java.util.*;
import java.io.*;
import org.semanticweb.triple.inference.builtins.BuiltinConfig;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class SimpleParser {
    char c, d;
    int vars = 0;
    int rule = 0;
    SimpleEvaluator engine;
    BuiltinConfig builtins;
    RuleSet RS;
    Symbolhandler symbols;
    boolean fini;
    ASCII_UCodeESC_CharStream is;
    Hashtable varmap = new Hashtable(20);
    Vector Vars, Nums;
    // the following two variables are variables to speed up the
    // parsing of single facts. The parser is therefore a litte bit
    // ugly...
    Vector Heads = new Vector(10, 5);
    int atomsymbol;
    boolean query;


    /**
     *  Constructor for the SimpleParser object
     *
     *@param  engine  Description of the Parameter
     *@param  stream  Description of the Parameter
     */
    public SimpleParser(SimpleEvaluator engine, InputStream stream) {
        this.engine = engine;
        is = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final boolean Arrow() throws SimpleParseException {
        if (c == '<') {
            try {
                d = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + d + ". Unexpected End of File");
            }
            if (d == '-') {
                skip();
                return true;
            }
            else {
                is.backup(1);
                return false;
            }
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Body BodyAtom() throws SimpleParseException {
        Term[] args;
        String s;
        int code;
        Body b = null;
        boolean neg = false;
        if (c == '-') {
            neg = true;
            skip();
        }
        s = Identifier();
        if (c == '(') {
            skip();
            args = ParameterList();
            BracketRight();
            code = symbols.searchAndInsertPredicateSymbols(s, args.length);
            if (code < builtins.getBuiltinNumber()) {
                b = new BuiltinBody(code, neg, args, builtins.newInstance(code));
            }
            else {
                b = new Body(code, neg, args);
            }

        }
        else {
            code = symbols.searchAndInsertPredicateSymbols(s, 0);
            if (code < builtins.getBuiltinNumber()) {
                b = new BuiltinBody(code, neg, new Term[0], builtins.newInstance(code));
            }
            else {
                b = new Body(code, neg, new Term[0]);
            }
        }
        return b;
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Body[] BodyKonjunktion() throws SimpleParseException {
        Body ruempfe[];
        Vector Bodies = new Vector(10, 5);
        Bodies.addElement(BodyAtom());
        while (c == '&') {
            skip();
            Bodies.addElement(BodyAtom());
        }
        int l = Bodies.size();
        ruempfe = new Body[l];

        //Sort Body Atoms (positive first, negative last)
        int i;
        int k = 0;
        for (i = 0; i < l; i++) {
            if ((!((Body) Bodies.elementAt(i)).isNegated())) {
                ruempfe[k] = (Body) (Bodies.elementAt(i));
                k++;
            }
        }
        for (i = 0; i < l; i++) {
            if (((Body) Bodies.elementAt(i)).isNegated()) {
                ruempfe[k] = (Body) (Bodies.elementAt(i));
                k++;
            }
        }
        // Bodies.copyInto(ruempfe);
        return ruempfe;
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final boolean BracketLeft() throws SimpleParseException {
        if (c != '(') {
            return false;
        }
        else {
            skip();
            return true;
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    final void BracketRight() throws SimpleParseException {
        if (c != ')') {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Closing Bracket expected");
        }
        skip();
    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    public final void compile() throws SimpleParseException {
        RS = engine.getRuleset();
        symbols = engine.getSymbolhandler();
        builtins = engine.getBuiltins();
        skip();
        while (!fini) {
            Rule();
        }
        is.Done();
    }


    /**
     *  Description of the Method
     *
     *@param  first                     Description of the Parameter
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Atom HeadAtom(boolean first) throws SimpleParseException {
        Term[] args;
        String s = Identifier();
        if (c == '(') {
            skip();
            args = ParameterList();
            BracketRight();
            atomsymbol = symbols.searchAndInsertPredicateSymbols(s, args.length);
            if (first && c == '.' && vars == 0) {
                return new Atom(args);
            }
            else {
                return new Head(atomsymbol, args);
            }
        }
        else {
            atomsymbol = symbols.searchAndInsertPredicateSymbols(s, 0);
            if (first && c == '.' && vars == 0) {
                return new Atom(new Term[0]);
            }
            else {
                return new Head(atomsymbol, new Term[0]);
            }
        }

    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    final void HeadKonjunktion() throws SimpleParseException {
        Heads.addElement(HeadAtom(true));
        while (c == '&') {
            skip();
            Heads.addElement(HeadAtom(false));
        }
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final String Identifier() throws SimpleParseException {
        if (!isLetter()) {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Letter expected");
        }
        while (isLetter() || isDigit()) {
            //System.out.print(c);
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }
        }
        is.backup(1);
        String s = is.GetImage();
        skip();
        return s;
    }


    /**
     *  Gets the digit attribute of the SimpleParser object
     *
     *@return    The digit value
     */
    final boolean isDigit() {
        return (('0' <= c) && ('9' >= c));
    }


    /**
     *  Gets the letter attribute of the SimpleParser object
     *
     *@return    The letter value
     */
    final boolean isLetter() {
        return ((('a' <= c) && (('z' >= c))) || (('A' <= c) && (('Z' >= c))) || (c == '_'));
    }


    /**
     *  Gets the sign attribute of the SimpleParser object
     *
     *@return    The sign value
     */
    final boolean isSign() {
        return ((c == '+') || (c == '-'));
    }


    /**
     *  Gets the uppercaseletter attribute of the SimpleParser object
     *
     *@return    The uppercaseletter value
     */
    final boolean isUppercaseletter() {
        return ((('A' <= c) && ('Z' >= c)) || (c == '_'));
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Term[] ParameterList() throws SimpleParseException {
        Term[] t;
        Vector Param = new Vector(5, 2);
        Param.addElement(Term());
        while (c == ',') {
            skip();
            Param.addElement(Term());
        }
        t = new Term[Param.size()];
        Param.copyInto(t);
        return t;
    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    final void Punkt() throws SimpleParseException {
        if (c != '.') {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Point expected");
        }
        skip();
    }


    /**
     *  Description of the Method
     *
     *@param  stream  Description of the Parameter
     */
    public void ReInit(InputStream stream) {
        is.ReInit(stream, 1, 1);
    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    final void Rule() throws SimpleParseException {

        varmap.clear();
        vars = 0;
        query = false;

        if (Arrow()) {
            query = true;
            Vars = new Vector();
            Nums = new Vector();
            Body[] bodies = BodyKonjunktion();
            Rule r = new Rule(null, bodies);
            RS.AddRule(r);
            engine.Names.put(r, Vars);
            engine.Numbers.put(r, Nums);
            Punkt();
        }
        else {
            HeadKonjunktion();
            if (Arrow()) {
                Body[] bodies = BodyKonjunktion();
                Head[] heads = new Head[Heads.size()];
                Heads.copyInto(heads);
                Heads.removeAllElements();
                Rule r = new Rule(heads, bodies);
                RS.AddRule(r);
                Punkt();
            }
            else if (vars > 0 || Heads.size() > 1) {
                Head[] heads = new Head[Heads.size()];
                Heads.copyInto(heads);
                Heads.removeAllElements();
                Rule r = new Rule(heads, null);
                RS.AddRule(r);
                Punkt();
            }
            else {
                //r = new Rule(heads,null);
                //RS.AddRule(r);
                RS.AddFact(atomsymbol, (Atom) Heads.elementAt(0));
                Heads.removeAllElements();
                Punkt();
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  SimpleParseException  Description of the Exception
     */
    final void skip() throws SimpleParseException {
        try {
            c = is.BeginToken();
            while (((c == ' ') || (c == '\n') || (c == '\r'))) {
                c = is.readChar();
            }
            is.backup(1);
            c = is.BeginToken();
        } catch (java.io.IOException e) {
            fini = true;
        }
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Term Term() throws SimpleParseException {
        Term t = null;
        String s;
        int code;
        Term[] args;
        if (isUppercaseletter()) {
            return Variable();
        }
        else if (isLetter()) {
            s = Identifier();
            if (c == '(') {
                skip();
                args = ParameterList();
                BracketRight();
                code = symbols.searchAndInsertFunctionSymbols(s, args.length);
                return new ConstTerm(code, args);
            }
            else {
                code = symbols.searchAndInsertFunctionSymbols(s, 0);
                return new ConstTerm(code);
            }
        }
        else if (isDigit() || isSign()) {
            return new NumTerm(Zahl());
        }
        else if (c == '"') {
            //t = new StringTerm(Zeichenkette());
            code = symbols.searchAndInsertStrings(Zeichenkette());
            return new ConstTerm(code + SimpleEvaluatorConfig.STRINGSTART);
        }
        else {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Variable, Constant, Function, Number or String expected");
        }
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final Variable Variable() throws SimpleParseException {
        Variable v;
        String s = Identifier();
        Integer k = (Integer) varmap.get(s);
        if (k == null) {
            k = new Integer(vars);
            vars++;
            varmap.put(s, k);
            if (query) {
                Vars.addElement(s);
                Nums.addElement(k);
            }
        }
        return new Variable(k.intValue());
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final double Zahl() throws SimpleParseException {
        Double zahl;
        String s;
        // Vorkommateil
        if (isSign()) {
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }

            if (!isDigit()) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". digit expected");
            }
        }
        while (isDigit()) {
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }
        }
        // Nachkommateil
        if (c == '.') {
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }
            while (isDigit()) {
                try {
                    c = is.readChar();
                } catch (java.io.IOException e) {
                    throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
                }
            }
        }
        // Exponent
        if ((c == 'e') || (c == 'E')) {
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }
            if (!isSign() && !isDigit()) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". +,- or digit expected");
            }
            else {
                if (isSign()) {
                    try {
                        c = is.readChar();
                    } catch (java.io.IOException e) {
                        throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
                    }
                    if (!isDigit()) {
                        throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". digit expected");
                    }
                }
                while (isDigit()) {
                    try {
                        c = is.readChar();
                    } catch (java.io.IOException e) {
                        throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
                    }
                }
            }
        }
        is.backup(1);
        s = is.GetImage();
        try {
            zahl = new Double(s);
        } catch (NumberFormatException p) {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". number expected");
        }
        skip();
        return zahl.doubleValue();
    }


    /**
     *  Description of the Method
     *
     *@return                           Description of the Return Value
     *@exception  SimpleParseException  Description of the Exception
     */
    final String Zeichenkette() throws SimpleParseException {
        String s;
        try {
            c = is.BeginToken();
        } catch (java.io.IOException e) {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
        }
        while (c != '"') {
            try {
                c = is.readChar();
            } catch (java.io.IOException e) {
                throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
            }
        }
        is.backup(1);
        s = is.GetImage();
        try {
            c = is.readChar();
        } catch (java.io.IOException e) {
            throw new SimpleParseException("Line:" + is.getEndLine() + ".Column:" + is.getEndColumn() + ". Encountered  " + c + ". Unexpected End of File");
        }
        skip();
        return s;
    }
}
