package org.semanticweb.triple.inference;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

/*
 *  Name: Substitution.java
 *  Version: 1.0
 *  Purpose: represents a substitution
 *  History:
 */
public class Substitution extends Atoms {
    // beinhaltet eine Menge von Variablensubstitutionen
    int index[];


    // index[i] gibt die Spalte in der Tabelle fuer Variable i an

    /**
     *  Constructor for the Substitution object
     *
     *@param  index    Description of the Parameter
     *@param  anzvars  Description of the Parameter
     */
    public Substitution(int index[], int anzvars) {
        // Index ist ein Index auf die Variablen s.o.
        // anzvars gibt die Anzahl aller Variablen an
        super(anzvars);
        this.index = index;
    }


    /**
     *  Description of the Method
     *
     *@param  A  Description of the Parameter
     *@return    Description of the Return Value
     */
    public Atoms Substitute(Atom A) {
        // Substitution der Variablen im Atom A durch die Menge der Variablensubstitutionen
        Atoms result;
        result = new Atoms(A.terms.length);
        result.Substitute(A, this, index);
        return result;
    }
}
