package org.semanticweb.triple.inference;
import java.io.*;

/**
 *  Description of the Interface
 *
 *@author     Administrator
 *@created    January 17, 200 Name: Symbolhandler.java Version: 1.0 Purpose:
 *      Interface for accessing a symbols History:
 */

public interface Symbolhandler {

    /*
     *  public void writePredicateSymbols(RandomAccessFile f) throws IOException;
     *  / s.a.
     */
    // s.a.

    /**
     *  Gets the contentFunctionSymbols attribute of the Symbolhandler object
     *
     *@param  i  Description of the Parameter
     *@return    The contentFunctionSymbols value
     */
    public String getContentFunctionSymbols(int i);


    // s.a.

    /**
     *  Gets the contentPredicateSymbols attribute of the Symbolhandler object
     *
     *@param  i  Description of the Parameter
     *@return    The contentPredicateSymbols value
     */
    public String getContentPredicateSymbols(int i);


    // Same as above, besides it also stores the String if it

    // is not allready in the database

    /**
     *  Gets the contentStrings attribute of the Symbolhandler object
     *
     *@param  i  Description of the Parameter
     *@return    The contentStrings value
     */
    public String getContentStrings(int i);


    // returns the number of Strings stored, needed only for storing the internal format

    /**
     *  Gets the insertMode attribute of the Symbolhandler object
     *
     *@return    The insertMode value
     */
    public boolean getInsertMode();


    //s.a.

    /**
     *  Gets the sizeFunctionSymbols attribute of the Symbolhandler object
     *
     *@return    The sizeFunctionSymbols value
     */
    public int getSizeFunctionSymbols();


    //s.a.

    /**
     *  Gets the sizePredicateSymbols attribute of the Symbolhandler object
     *
     *@return    The sizePredicateSymbols value
     */
    public int getSizePredicateSymbols();


    // returns the string based on the index

    /**
     *  Gets the sizeStrings attribute of the Symbolhandler object
     *
     *@return    The sizeStrings value
     */
    public int getSizeStrings();


    /**
     *  Description of the Method
     */
    public void rollback();


    // same as String, except is look for symbols (s) with an certain arity

    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@param  a  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchAndInsertFunctionSymbols(String s, int a);


    // same as String, except is look for symbols (s) with an certain arity

    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@param  a  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchAndInsertPredicateSymbols(String s, int a);


    // Interface method for seaching stored String objects

    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchAndInsertStrings(String s);


    // do we want to add or delete symbols

    /*
     *  // According to Juergen not necessary anymore
     *  public void writeStrings(RandomAccessFile f) throws IOException;
     *  / write Strings to file, neeed for storing the internal format
     */
    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@param  a  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchFunctionSymbols(String s, int a);


    // s.a.

    /*
     *  public void writeFunctionSymbols(RandomAccessFile f) throws IOException;
     *  / s.a.
     */
    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@param  a  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchPredicateSymbols(String s, int a);


// the following methods are used during the parsing process, during evaluation and during substitution output

// the parsing lookup has to be done very fast (currently log(n))
// everything else would be desasterous

    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int searchStrings(String s);


    // do we want to add or delete symbols

    /**
     *  Sets the insertMode attribute of the Symbolhandler object
     *
     *@param  insertMode  The new insertMode value
     */
    public void setInsertMode(boolean insertMode);


    // s.a.

    /**
     *  Sets the rollbackPoint attribute of the Symbolhandler object
     */
    public void setRollbackPoint();
}
