package org.semanticweb.triple.inference.builtins;

/*
 *  Name: Write.java
 *  Version: 1.0
 *  Purpose: Regular Expression Support for inference engine
 *  History:
 */
import java.io.*;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Term;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.SimpleEvaluator;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class Write extends BuiltinFunc {

    /**
     *  Constructor for the Write object
     */
    public Write() {
        super();
    }


    /**
     *  Constructor for the Write object
     *
     *@param  eval  Description of the Parameter
     */
    public Write(SimpleEvaluator eval) {

        super(eval);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        int length = t.terms.length;
        for (int i = 0; i < length; i++) {
            org.semanticweb.triple.inference.Term arg = t.terms[i];
            org.semanticweb.lp.Term f = eval.toSimpleTerm(arg, eval.getSymbolhandler());
            System.out.print(f.toString());
        }
        insert(t);

    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        return true;
    }
}
