package org.semanticweb.triple.inference.builtins;
import java.lang.Math;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

public class between extends BuiltinFunc {

    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        boolean ok = false;
        double zahl0;
        double zahl1;
        double zahl2;
        if ((t.terms[0] instanceof NumTerm) && (t.terms[1] instanceof NumTerm) && (t.terms[2] instanceof NumTerm)) {
            zahl0 = ((NumTerm) t.terms[0]).zahl;
            zahl1 = ((NumTerm) t.terms[1]).zahl;
            zahl2 = ((NumTerm) t.terms[2]).zahl;
            if ((zahl0 <= zahl1) && (zahl1 <= zahl2)) {
                ok = true;
            }
        }
        if (ok) {
            insert(t);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        boolean res;
        res = (t.terms[0] instanceof NumTerm) && (t.terms[1] instanceof NumTerm) && (t.terms[2] instanceof NumTerm);
        return res;
    }
}
